
message(STATUS "non-blocking sockets style")


set(TEST1 "${TEST1}#include <sys/types.h>\n")
set(TEST1 "${TEST1}#include <unistd.h>\n")
set(TEST1 "${TEST1}#include <fcntl.h>\n")
set(TEST1 "${TEST1}int main() {\n")
set(TEST1 "${TEST1}#if defined(sun) || defined(__sun__) || defined(__SUNPRO_C) || defined(__SUNPRO_CC)\n")
set(TEST1 "${TEST1}# if defined(__SVR4) || defined(__srv4__)\n")
set(TEST1 "${TEST1}#  define PLATFORM_SOLARIS\n")
set(TEST1 "${TEST1}# else\n")
set(TEST1 "${TEST1}#  define PLATFORM_SUNOS4\n")
set(TEST1 "${TEST1}# endif\n")
set(TEST1 "${TEST1}#endif\n")
set(TEST1 "${TEST1}#if (defined(_AIX) || defined(__xlC__)) && !defined(_AIX41)\n")
set(TEST1 "${TEST1}# define PLATFORM_AIX_V3\n")
set(TEST1 "${TEST1}#endif\n")
set(TEST1 "${TEST1}\n")
set(TEST1 "${TEST1}#if defined(PLATFORM_SUNOS4) || defined(PLATFORM_AIX_V3) || defined(__BEOS__)\n")
set(TEST1 "${TEST1}#error \"O_NONBLOCK does not work on this platform\"\n")
set(TEST1 "${TEST1}#endif\n")
set(TEST1 "${TEST1}  int socket;\n")
set(TEST1 "${TEST1}  int flags = fcntl(socket, F_SETFL, flags | O_NONBLOCK);\n")
set(TEST1 "${TEST1};return 0;}\n")

set(TEST2 "${TEST2}#include <unistd.h>\n")
set(TEST2 "${TEST2}#include <stropts.h>\n")
set(TEST2 "${TEST2}int main () {\n")
set(TEST2 "${TEST2} int socket;\n")
set(TEST2 "${TEST2} int flags = ioctl(socket, FIONBIO, &flags);\n")
set(TEST2 "${TEST2} ;return 0;}\n")

set(TEST3 "${TEST3}#undef inline\n")
if(HAVE_WINDOWS_H)
  set(TEST3 "${TEST3}#ifndef WIN32_LEAN_AND_MEAN\n")
  set(TEST3 "${TEST3}#  define WIN32_LEAN_AND_MEAN\n")
  set(TEST3 "${TEST3}#endif\n")
  set(TEST3 "${TEST3}#include <windows.h>\n")
if(HAVE_WINSOCK2_H)
  set(TEST3 "${TEST3}#include <winsock2.h>\n")
else(HAVE_WINSOCK2_H)
  set(TEST3 "${TEST3}#include <winsock.h>\n")
endif(HAVE_WINSOCK2_H)
endif(HAVE_WINDOWS_H)
set(TEST3 "${TEST3}int main () {\n")
set(TEST3 "${TEST3} SOCKET sd;\n")
set(TEST3 "${TEST3} unsigned long flags = 0;\n")
set(TEST3 "${TEST3} sd = socket(0, 0, 0);\n")
set(TEST3 "${TEST3} ioctlsocket(sd, FIONBIO, &flags);\n")
set(TEST3 "${TEST3};return 0;}\n")

set(TEST4 "${TEST4}#include <sys/ioctl.h>\n")
set(TEST4 "${TEST4}int main () {\n")
set(TEST4 "${TEST4} int socket;\n")
set(TEST4 "${TEST4} int flags = IoctlSocket(socket, FIONBIO, (long)1);\n")
set(TEST4 "${TEST4};return 0;}\n")

set(TEST5 "${TEST5}#include <socket.h>\n")
set(TEST5 "${TEST5}int main () {\n")
set(TEST5 "${TEST5} long b = 1;\n")
set(TEST5 "${TEST5} int socket;\n")
set(TEST5 "${TEST5} int flags = setsockopt(socket, SOL_SOCKET, SO_NONBLOCK, &b, sizeof(b));\n")
set(TEST5 "${TEST5};return 0;}\n")


if(HAVE_O_NONBLOCK OR HAVE_FIONBIO OR HAVE_IOCTLSOCKET OR HAVE_IOCTLSOCKET_CASE OR HAVE_SO_NONBLOCK OR HAVE_DISABLED_NONBLOCKING)
  message("All done - ${HAVE_O_NONBLOCK} - ${HAVE_FIONBIO} - ${HAVE_IOCTLSOCKET} - ${HAVE_IOCTLSOCKET_CASE} - ${HAVE_SO_NONBLOCK} - ${HAVE_DISABLED_NONBLOCKING}")
  return()
endif(HAVE_O_NONBLOCK OR HAVE_FIONBIO OR HAVE_IOCTLSOCKET OR HAVE_IOCTLSOCKET_CASE OR HAVE_SO_NONBLOCK OR HAVE_DISABLED_NONBLOCKING)


include(CheckCSourceCompiles)
CHECK_C_SOURCE_COMPILES("${TEST1}" O_NONBLOCK_COMPILES)
if(O_NONBLOCK_COMPILES)
  set(HAVE_O_NONBLOCK ON CACHE BOOL "use O_NONBLOCK for non-blocking sockets")
else(O_NONBLOCK_COMPILES)
  CHECK_C_SOURCE_COMPILES("${TEST2}" FIONBIO_COMPILES)
  if(FIONBIO_COMPILES)
    set(HAVE_FIONBIO ON CACHE BOOL "use FIONBIO for non-blocking sockets")
  else(FIONBIO_COMPILES)
    set(CMAKE_REQUIRED_LIBRARIES_BACKUP "${CMAKE_REQUIRED_LIBRARIES}")
    set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES};wsock32")
    CHECK_C_SOURCE_COMPILES("${TEST3}" IOCTLSOCKET_COMPILES)
    set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES_BACKUP}")
    if(IOCTLSOCKET_COMPILES)
      set(HAVE_IOCTLSOCKET ON CACHE BOOL "use ioctlsocket() for non-blocking sockets")
    else(IOCTLSOCKET_COMPILES)
      CHECK_C_SOURCE_COMPILES("${TEST4}" IOCTLSOCKET_CASE_COMPILES)
      if(IOCTLSOCKET_CASE_COMPILES)
        set(HAVE_IOCTLSOCKET_CASE ON CACHE BOOL "use Ioctlsocket() for non-blocking sockets")
      else(IOCTLSOCKET_CASE_COMPILES)
        CHECK_C_SOURCE_COMPILES("${TEST5}" SO_NONBLOCK_COMPILES)
        if(SO_NONBLOCK_COMPILES)
          set(HAVE_SO_NONBLOCK ON CACHE BOOL "use SO_NONBLOCK for non-blocking sockets")
        else(SO_NONBLOCK_COMPILES)
          set(HAVE_DISABLED_NONBLOCKING ON CACHE BOOL "disabled non-blocking sockets")
        endif(SO_NONBLOCK_COMPILES)
      endif(IOCTLSOCKET_CASE_COMPILES)
    endif(IOCTLSOCKET_COMPILES)
  endif(FIONBIO_COMPILES)
endif(O_NONBLOCK_COMPILES)
